/*
{
  "IMPORTED" : [

  ],
  "CATEGORIES" : [
    "Effect"
  ],
  "DESCRIPTION" : "Author @kyndinfo - 2016 https:\/\/thebookofshaders.com\/edit.php?log=160909064609 Modified by Oriol Pastor",
  "ISFVSN" : "2",
  "INPUTS" : [
    {
      "NAME" : "color_chaser",
      "TYPE" : "color",
      "DEFAULT" : [
        0.99999600649999998,
        1,
        1,
        1
      ]
    },
    {
      "NAME" : "inputImage",
      "TYPE" : "image"
    },
    {
      "NAME" : "speed",
      "TYPE" : "float",
      "MAX" : 8,
      "DEFAULT" : 0.25,
      "MIN" : 0
    }
  ]
}
*/

vec3 iResolution = vec3(RENDERSIZE, 1.);

float stepUpDown(float begin, float end, float t) {
  return step(begin, t) - step(end, t);
}

void main() {
    vec2 st = gl_FragCoord.xy / iResolution.xy;
    float t = fract(TIME * speed), v;
    if (st.x < 0.5) {
        if (st.y < 0.5) {
            v = stepUpDown(0.0, 0.125, t);
        } else {
            v = stepUpDown(0.25, 0.375, t);
        }
    } else {
        if (st.y > 0.5) {
            v = stepUpDown(0.5, 0.625, t);
        } else {
            v = stepUpDown(0.75, 0.875, t);
        }
    }
    
    vec4 background = IMG_NORM_PIXEL(inputImage, st);

    vec4 color = mix(background, color_chaser, v);
    gl_FragColor = vec4(color);
}