/*
{
  "IMPORTED" : [

  ],
  "CATEGORIES" : [
    "Effect"
  ],
  "DESCRIPTION" : "Author @kyndinfo - 2016 https:\/\/thebookofshaders.com\/edit.php?log=160909064609 Modified by Oriol Pastor",
  "ISFVSN" : "2",
  "INPUTS" : [
    {
      "NAME" : "color_chaser",
      "TYPE" : "color",
      "DEFAULT" : [
        0.99999600649999998,
        1,
        1,
        1
      ]
    },
    {
      "NAME" : "inputImage",
      "TYPE" : "image"
    },
    {
      "NAME" : "speed",
      "TYPE" : "float",
      "MAX" : 8,
      "DEFAULT" : 0.25,
      "MIN" : 0
    },
    {
      "NAME" : "size",
      "TYPE" : "float",
      "MAX" : 0.20000000000000001,
      "DEFAULT" : 0.15,
      "MIN" : 0
    }
  ]
}
*/

vec3 iResolution = vec3(RENDERSIZE, 1.);

float linearstep(float begin, float end, float t) {
    return clamp((t - begin) / (end - begin), 0.0, 1.0);
}

float easeInOutExpo(float t) {
    if (t == 0.0 || t == 1.0) {
        return t;
    }
    if ((t *= 2.0) < 1.0) {
        return 0.5 * pow(2.0, 10.0 * (t - 1.0));
    } else {
        return 0.5 * (-pow(2.0, -10.0 * (t - 1.0)) + 2.0);
    }
}

float smoothedge(float v, float f) {
    return smoothstep(0.0, f / iResolution.x, v);
}

float rect(vec2 p, vec2 size) {
  vec2 d = abs(p) - size;
  return min(max(d.x, d.y), 0.0) + length(max(d,0.0));
}

float rectPlot(vec2 p, vec2 size) {
  return 1.0 - smoothedge(rect(p, size), 1.0);
}

float chaser(vec2 p, float t) {
    float t0 = linearstep(0.0, 0.25, t);
    float x0 = easeInOutExpo(t0);
    float t1 = linearstep(0.5, 0.75, t);
    float x1 = easeInOutExpo(t1);

    float t2 = linearstep(0.25, 0.5, t);
    float y0 = easeInOutExpo(t2);
    float t3 = linearstep(0.75, 1.0, t);
    float y1 = easeInOutExpo(t3);

    return rectPlot(p - vec2(mix(0.2, 0.8, x0 - x1), mix(0.2, 0.8, y0 - y1)), vec2(size));
}

float chasers(vec2 st, float t) {
    t = fract(t);
    float v = chaser(st, fract(t));
    v = max(v, chaser(st, fract(t + 0.25)));
    v = max(v, chaser(st, fract(t + 0.5)));
    v = max(v, chaser(st, fract(t + 0.75)));
    return v;
}


void main() {
    vec2 st = gl_FragCoord.xy / iResolution.xy;
	float t = fract(TIME * speed);
    float v = chasers(st, t);
    
    
    vec4 background = IMG_NORM_PIXEL(inputImage, st);

    vec4 color = mix(background, color_chaser, v);
    gl_FragColor = vec4(color);
}