/*
{
  "IMPORTED" : [

  ],
  "CATEGORIES" : [
    "Effect"
  ],
  "DESCRIPTION" : "Author @kyndinfo - 2016 https:\/\/thebookofshaders.com\/edit.php?log=160909064357 Modified by Oriol Pastor",
  "ISFVSN" : "2",
  "INPUTS" : [
    {
      "NAME" : "color_chaser",
      "TYPE" : "color",
      "DEFAULT" : [
        0.99999600649999998,
        1,
        1,
        1
      ]
    },
    {
      "NAME" : "inputImage",
      "TYPE" : "image"
    },
    {
      "NAME" : "speed",
      "TYPE" : "float",
      "MAX" : 8,
      "DEFAULT" : 1,
      "MIN" : 0
    }
  ]
}
*/

vec3 iResolution = vec3(RENDERSIZE, 1.);

float stepUpDown(float begin, float end, float t) {
  return step(begin, t) - step(end, t);
}

void main() {
    vec2 st = gl_FragCoord.xy / iResolution.xy;
float t = fract(TIME* speed), n = st.x * 4., v;

    if (n < 1.0) {
      v = step(0.5, t);
    } else if (n < 2.0) {
      v = 1.0 - step(0.5, t);
    } else if (n < 3.0) {
      v = stepUpDown(0.25, 0.5, t);
    } else {
      v = stepUpDown(0.5, 0.75, t);
    }
    
    
    vec4 background = IMG_NORM_PIXEL(inputImage, st);

    vec4 color = mix(background, color_chaser, v);
    gl_FragColor = vec4(color);
}