/*
{
  "IMPORTED" : [

  ],
  "CATEGORIES" : [
    "Effect"
  ],
  "DESCRIPTION" : "Author @kyndinfo - 2016 https:\/\/thebookofshaders.com\/edit.php?log=160909064458 Modified by Oriol Pastor",
  "ISFVSN" : "2",
  "INPUTS" : [
    {
      "NAME" : "color_chaser",
      "TYPE" : "color",
      "DEFAULT" : [
        0.99999600649999998,
        1,
        1,
        1
      ]
    },
    {
      "NAME" : "inputImage",
      "TYPE" : "image"
    },
    {
      "NAME" : "speed",
      "TYPE" : "float",
      "MAX" : 8,
      "DEFAULT" : 0.25,
      "MIN" : 0
    }
  ]
}
*/

vec3 iResolution = vec3(RENDERSIZE, 1.);

float linearstep(float begin, float end, float t) {
    return clamp((t - begin) / (end - begin), 0.0, 1.0);
}

float linearstepUpDown(float upBegin, float upEnd, float downBegin, float downEnd, float t) {
    return linearstep(upBegin, upEnd, t) - linearstep(downBegin, downEnd, t);
}

float plot(vec2 st, float pct){
  return  smoothstep( pct - 0.005, pct, st.y) -
          smoothstep( pct, pct + 0.005, st.y);
}


void main() {
    vec2 st = gl_FragCoord.xy / iResolution.xy;
float t = fract(TIME* speed), n0 = st.x * 4., n1 = st.y * speed, v0, v1;



    // Bar animations
    if (n0 < 1.0) {
      v0 = linearstep(0.25, 0.75, t);
    } else if (n0 < 2.0) {
      v0 = 1.0 - linearstep(0.25, 0.75, t);
    } else if (n0 < 3.0) {
      v0 = linearstepUpDown(0.1, 0.3, 0.5, 0.7, t);
    } else {
      v0 = linearstepUpDown(0.3, 0.5, 0.7, 0.9, t);
    }    
    
    vec4 background = IMG_NORM_PIXEL(inputImage, st);

    vec4 color = mix(background, color_chaser, v0);
    gl_FragColor = vec4(color);
}