/*
{
  "IMPORTED" : [

  ],
  "CATEGORIES" : [
    "Effect"
  ],
  "DESCRIPTION" : "Author @kyndinfo - 2016 https:\/\/thebookofshaders.com\/edit.php?log=160909064357 Modified by Oriol Pastor",
  "ISFVSN" : "2",
  "INPUTS" : [
    {
      "NAME" : "color_chaser",
      "TYPE" : "color",
      "DEFAULT" : [
        0.99999600649999998,
        1,
        1,
        1
      ]
    },
    {
      "NAME" : "inputImage",
      "TYPE" : "image"
    },
    {
      "NAME" : "speed",
      "TYPE" : "float",
      "MAX" : 8,
      "DEFAULT" : 0.25,
      "MIN" : 0
    }
  ]
}
*/

vec3 iResolution = vec3(RENDERSIZE, 1.);

float stepUpDown(float begin, float end, float t) {
  return step(begin, t) - step(end, t);
}

void main() {
    vec2 st = gl_FragCoord.xy / iResolution.xy;
float t = fract(TIME*speed), n = st.y * 4., v;

    if (st.y > 0.) {
        if (st.x < 1.0 / 3.0) {
            v = stepUpDown(0.0, 1.0 / 3.0, t);
        } else if (st.x < 2.0 / 3.0) {
            v = stepUpDown(1.0 / 3.0, 2.0 / 3.0, t);
        } else {
            v = stepUpDown(2.0 / 3.0, 1.0, t);
        }
    
    }    
    
    vec4 background = IMG_NORM_PIXEL(inputImage, st);

    vec4 color = mix(background, color_chaser, v);
    gl_FragColor = vec4(color);
}