/*
{
  "IMPORTED" : [

  ],
  "CATEGORIES" : [
    "Effect"
  ],
  "DESCRIPTION" : "Author @kyndinfo - 2016 https://thebookofshaders.com/edit.php?log=160909065049 Modified by Oriol Pastor",
  "ISFVSN" : "2",
  "INPUTS" : [
    {
      "NAME" : "color_chaser",
      "TYPE" : "color",
      "DEFAULT" : [
        0.99999600649999998,
        1,
        1,
        1
      ]
    },
    {
      "NAME" : "inputImage",
      "TYPE" : "image"
    },
    {
      "NAME" : "speed",
      "TYPE" : "float",
      "MAX" : 8,
      "DEFAULT" : 1,
      "MIN" : 0
    }
  ]
}
*/

#define PI 3.14159265359
#define TWO_PI 6.28318530718

vec3 iResolution = vec3(RENDERSIZE, 1.);

float easeOutQuad(float t) {
    return -1.0 * t * (t - 2.0);
}

float easeOutCubic(float t) {
    return (t = t - 1.0) * t * t + 1.0;
}

float easeInCubic(float t) {
    return t * t * t;
}

float easeInOutCubic(float t) {
    if ((t *= 2.0) < 1.0) {
        return 0.5 * t * t * t;
    } else {
        return 0.5 * ((t -= 2.0) * t * t + 2.0);
    }
}


float linearstep(float begin, float end, float t) {
    return clamp((t - begin) / (end - begin), 0.0, 1.0);
}




float smoothedge(float v, float f) {
    return smoothstep(0.0, f / iResolution.x, v);
}


float rect(vec2 p, vec2 size) {
  vec2 d = abs(p) - size;
  return min(max(d.x, d.y), 0.0) + length(max(d,0.0));
}

float rectPlot(vec2 p, vec2 size) {
  return 1.0 - smoothedge(rect(p, size), 1.0);
}





void main() {
    vec2 st = gl_FragCoord.xy / iResolution.xy;
    vec2 center = vec2(0.5);
    
	float t = mod(TIME*speed, 4.);
      // WIPE - ZOOM

    
    float t01 = easeInOutCubic(linearstep(0., 0.0, t));
    
    
    vec2 st01 = st;
    st01.x += t01 - 1.0;
    float v = rectPlot(st01 - center, vec2(mix(0., 0.5, easeInCubic(linearstep(2.75, 3.25, t)))));
   
	
	
    
    
    vec4 background = IMG_NORM_PIXEL(inputImage, st);

    vec4 color = mix(background, color_chaser, v);
    gl_FragColor = vec4(color);
}